<template>
   <div>
     <apexchart width="100%" height="500px" type="donut" :options="chartData" :series="chartData.series"></apexchart>
   </div>
</template>

<script>

export default {
  props: {
    participants: {
      required: true
    }
  },
  computed: {
    chartData() {

        let toRet = {
            context: this,
            names: [],
            labels: [],
            series: [],
            legend: {
                show: true,
                position: 'bottom',
                horizontalAlign: 'center', 
                onItemClick: {
                    toggleDataSeries: false
                },
                onItemHover: {
                    highlightDataSeries: true
                },
            },
            tooltip: {
                enabled: true,
                y: {
                    formatter: function(value, opts) {
                        let timeVals = opts.config.context.getHoursMinutesSeconds(
                            opts.globals.series[opts.seriesIndex]
                        );
                        return opts.config.context.$t("complete_conference.talk_time_short", timeVals);
                    }
                }
            },
            dataLabels: {
                enabled:true,
                offset: 10,
                minAngleToShowLabel: 12,
                formatter: function (val, opts) {
                    let timeVals = opts.w.config.context.getHoursMinutesSeconds(
                        opts.w.config.series[opts.seriesIndex]
                    );
                    let timeString = opts.w.config.context.$t("complete_conference.talk_time_short", timeVals);
                    
                    if(val > 15)
                    {
                        return [opts.w.config.names[opts.seriesIndex], timeString]
                    }
                    
                    return timeString;
                },
                dropShadow: {
                    top: 0,
                    left: 0,
                    blur: 0.8,
                    color: '#000',
                    opacity: 1
                }
            },
            plotOptions: {
                pie: {
                    donut: {

                        labels: {
                            show: true,
                            name: {
                                show: true,
                                fontSize: '20px',
                                fontFamily: 'Helvetica, Arial, sans-serif',
                                fontWeight: 600,
                                formatter: function (val) {
                                    let splitname = val.split('(+');
                                    return splitname[0];
                                }
                            },
                            value: {
                                show: true,
                                fontSize: '16px',
                                fontFamily: 'Helvetica, Arial, sans-serif',
                                fontWeight: 400,
                                color: undefined,
                                offsetY: 16,
                                formatter: function (val, opts) {
                                    let timeVals = opts.config.context.getHoursMinutesSeconds(val);
                                    return opts.config.context.$t("complete_conference.talk_time", timeVals)
                                }
                            },
                        }
                    }
                }
            }
        } 
        

        let numbers = Object.keys(this.participants);
        numbers.forEach(num =>
        {
            toRet.names.push(this.participants[num].Name)
            toRet.labels.push(this.participants[num].Name + " (" + num +")")
            toRet.series.push(this.participants[num].TalkTime ?? 0 /1000)
        });

        return toRet;
    }
  },
  watch: {

  },
  methods: {
      getHoursMinutesSeconds(milliSecondsIn) {
      const secondsIn = milliSecondsIn / 1000;
      const hours = Math.floor(secondsIn / 60 / 60);
      const minutes = Math.floor((secondsIn - hours * 60 * 60) / 60);
      const seconds = Math.round(secondsIn - hours * 60 * 60 - minutes * 60);
      return {
        hours,
        minutes,
        seconds,
      };
    },
  }
};
</script>